//
//  ViewController.m
//  OpenCV Camera Test
//
//  Created by Robert Nitsch on 20.11.13.
//  Copyright (c) 2013 Robert Nitsch. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    self.camera = [[CvVideoCamera alloc] initWithParentView:self.imageView];
    self.camera.delegate = self;
    self.camera.defaultAVCaptureDevicePosition = AVCaptureDevicePositionBack;
    self.camera.defaultAVCaptureSessionPreset = AVCaptureSessionPresetHigh;
    self.camera.defaultAVCaptureVideoOrientation = AVCaptureVideoOrientationPortrait;
    self.camera.defaultFPS = 15;
    self.camera.grayscaleMode = NO;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidAppear:(BOOL)animated
{
    // THIS IS WHAT OPENCV DOES
    [self.camera start];
    
    /*
    // THIS IS WHAT AVCAPTURESESSION DOES
    AVCaptureSession *session = [[AVCaptureSession alloc] init];
    [session setSessionPreset:AVCaptureSessionPresetMedium];
    
    AVCaptureDevice *inputDevice;
	for (AVCaptureDevice *i in [AVCaptureDevice devicesWithMediaType:AVMediaTypeVideo]) {
        if ([i position] == AVCaptureDevicePositionBack) {
            inputDevice = i;
            break;
        }
    }
    
    NSError *error;
    AVCaptureDeviceInput *deviceInput = [AVCaptureDeviceInput deviceInputWithDevice:inputDevice error:&error];
    if ( [session canAddInput:deviceInput] )
        [session addInput:deviceInput];
    
    AVCaptureVideoPreviewLayer *previewLayer = [[AVCaptureVideoPreviewLayer alloc] initWithSession:session];
    UIView *aView = self.imageView;
    previewLayer.frame = aView.bounds; // Assume you want the preview layer to fill the view.
    previewLayer.videoGravity = AVLayerVideoGravityResizeAspectFill;
    [aView.layer addSublayer:previewLayer];
    
    [session startRunning];
    */
    
	/*
    // THIS IS WHAT HAPPENS WHEN YOU START/STOP OPENCV CAMERA MANY TIMES
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
    	for (;;) {
            dispatch_sync(dispatch_get_main_queue(), ^{ [self.camera start]; });
            [NSThread sleepForTimeInterval:1.0];
            dispatch_sync(dispatch_get_main_queue(), ^{ [self.camera stop]; });
            [NSThread sleepForTimeInterval:1.0];
        }
    });
	//*/
}

#ifdef __cplusplus
-(void)processImage:(cv::Mat&)image
{
    
}
#endif

@end
